From 0ac652c5d97cfceff5945b6aaec59aa923a0fecc Mon Sep 17 00:00:00 2001
From: tristanliu <37809633+sevenliu1896@users.noreply.github.com>
Date: Mon, 31 Jul 2023 11:23:37 +0800
Subject: [PATCH] semantic-fe  visual modeling  pr (#21)

* [improvement][semantic-fe] Added an editing component to set filtering rules for Q&A. Now, the SQL editor will be accompanied by a list for display and control, to resolve ambiguity when using comma-separated values.
[improvement][semantic-fe] Improved validation logic and prompt copywriting for data source/dimension/metric editing and creation.
[improvement][semantic-fe] Improved user experience for visual modeling. Now, when using the legend to control the display/hide of data sources and their associated metric dimensions, the canvas will be re-layout based on the activated data source in the legend.

* [improvement][semantic-fe] Submitted a new version of the visual modeling tool.
[improvement][semantic-fe] Fixed an issue with the initialization of YoY and MoM metrics in Q&A settings.
[improvement][semantic-fe] Added a version field to the database settings.
[improvement][semantic-fe] 1. Added the ability to set YoY and MoM metrics in Q&A settings.2. Moved dimension value editing from the dimension editing window to the dimension list.

---------

Co-authored-by: tristanliu <tristanliu@tencent.com>
---
 .../src/components/StandardFormRow/index.less |  96 +++
 .../src/components/StandardFormRow/index.tsx  |  43 +
 .../src/components/TagSelect/index.less       |  33 +
 .../src/components/TagSelect/index.tsx        | 191 +++++
 webapp/packages/supersonic-fe/src/global.less |  15 +-
 .../src/pages/SemanticModel/ChatSetting.tsx   |  10 +-
 .../Metric/components/MetricFilter.tsx        | 109 +++
 .../pages/SemanticModel/Metric/constants.ts   |   0
 .../src/pages/SemanticModel/Metric/data.d.ts  |   0
 .../src/pages/SemanticModel/Metric/index.tsx  | 196 +++++
 .../src/pages/SemanticModel/Metric/model.ts   |   0
 .../src/pages/SemanticModel/Metric/service.ts |   0
 .../src/pages/SemanticModel/Metric/style.less |  10 +
 .../src/pages/SemanticModel/Metric/utils.ts   |   0
 .../pages/SemanticModel/ProjectManager.tsx    |  12 +-
 .../XflowJsonSchemaFormDrawerForm.tsx         |   2 +-
 .../SemanticGraph/components/ContextMenu.tsx  |  22 +-
 .../components/DeleteConfirmModal.tsx         |  20 +-
 .../SemanticGraph/components/GraphToolBar.tsx |  66 ++
 .../components/NodeInfoDrawer.tsx             | 292 +++++++
 .../SemanticGraph/components/ToolBar.tsx      |  65 +-
 .../SemanticModel/SemanticGraph/index.tsx     | 214 ++++-
 .../SemanticModel/SemanticGraph/style.less    | 776 +-----------------
 .../SemanticModel/SemanticGraph/utils.ts      | 129 ++-
 .../SemanticModel/SemanticGraphCanvas.tsx     |  10 +-
 .../components/ClassDataSourceTable.tsx       |  88 +-
 .../components/ClassDataSourceTypeModal.tsx   | 107 ++-
 .../components/ClassDataSourceTypeModal1.tsx  | 101 +++
 .../components/ClassDimensionTable.tsx        |  42 +-
 .../components/ClassMetricTable.tsx           |  33 +-
 .../components/CommonEditList/TextArea.tsx    | 166 ++++
 .../components/CommonEditTable.tsx            |  15 +-
 .../Database/DatabaseCreateForm.tsx           |  23 +-
 .../components/DimensionInfoModal.tsx         | 115 ++-
 .../components/DimensionValueSettingModal.tsx | 156 ++++
 .../components/Entity/DefaultSettingForm.tsx  |  78 +-
 .../Entity/DimensionAndMetricVisibleModal.tsx |  29 +-
 .../Entity/DimensionMetricVisibleForm.tsx     |   6 +-
 .../Entity/DimensionValueSettingForm.tsx      |   3 +-
 .../components/Entity/EntityCreateForm.tsx    |  35 +-
 .../components/Entity/EntitySection.tsx       |  23 +-
 .../Entity/EntitySettingSection.tsx           |  69 ++
 .../Entity/RecommendedQuestionsSection.tsx    |  87 ++
 .../SemanticModel/components/Entity/utils.ts  |  11 +-
 .../components/MetricInfoCreateForm.tsx       |   8 +-
 .../SemanticModel/components/TransTypeTag.tsx |  10 +-
 .../pages/SemanticModel/components/style.less |  21 +-
 .../src/pages/SemanticModel/data.d.ts         |  19 +-
 .../src/pages/SemanticModel/enum.ts           |   5 +
 .../src/pages/SemanticModel/service.ts        |   2 +-
 50 files changed, 2375 insertions(+), 1188 deletions(-)
 create mode 100644 webapp/packages/supersonic-fe/src/components/StandardFormRow/index.less
 create mode 100644 webapp/packages/supersonic-fe/src/components/StandardFormRow/index.tsx
 create mode 100644 webapp/packages/supersonic-fe/src/components/TagSelect/index.less
 create mode 100644 webapp/packages/supersonic-fe/src/components/TagSelect/index.tsx
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/Metric/components/MetricFilter.tsx
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/Metric/constants.ts
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/Metric/data.d.ts
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/Metric/index.tsx
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/Metric/model.ts
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/Metric/service.ts
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/Metric/style.less
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/Metric/utils.ts
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticGraph/components/GraphToolBar.tsx
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticGraph/components/NodeInfoDrawer.tsx
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/components/ClassDataSourceTypeModal1.tsx
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/components/CommonEditList/TextArea.tsx
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/components/DimensionValueSettingModal.tsx
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/components/Entity/EntitySettingSection.tsx
 create mode 100644 webapp/packages/supersonic-fe/src/pages/SemanticModel/components/Entity/RecommendedQuestionsSection.tsx

diff --git a/webapp/packages/supersonic-fe/src/components/StandardFormRow/index.tsx b/webapp/packages/supersonic-fe/src/components/StandardFormRow/index.tsx
new file mode 100644
index 000000000..57a0038ba
--- /dev/null
+++ b/webapp/packages/supersonic-fe/src/components/StandardFormRow/index.tsx
@@ -0,0 +1,43 @@
+import React from 'react';
+import classNames from 'classnames';
+import styles from './index.less';
+
+type StandardFormRowProps = {
+  title?: string;
+  last?: boolean;
+  block?: boolean;
+  grid?: boolean;
+  style?: React.CSSProperties;
+  titleClassName?: string;
+};
+
+const StandardFormRow: React.FC<StandardFormRowProps> = ({
+  title,
+  children,
+  last,
+  block,
+  grid,
+  titleClassName,
+  ...rest
+}) => {
+  const cls = classNames(styles.standardFormRow, {
+    [styles.standardFormRowBlock]: block,
+    [styles.standardFormRowLast]: last,
+    [styles.standardFormRowGrid]: grid,
+  });
+
+  const labelCls = classNames(styles.label, titleClassName);
+
+  return (
+    <div className={cls} {...rest}>
+      {title && (
+        <div className={labelCls}>
+          <span>{title}</span>
+        </div>
+      )}
+      <div className={styles.content}>{children}</div>
+    </div>
+  );
+};
+
+export default StandardFormRow;
diff --git a/webapp/packages/supersonic-fe/src/components/TagSelect/index.tsx b/webapp/packages/supersonic-fe/src/components/TagSelect/index.tsx
new file mode 100644
index 000000000..0e0020bb9
--- /dev/null
+++ b/webapp/packages/supersonic-fe/src/components/TagSelect/index.tsx
@@ -0,0 +1,191 @@
+import { DownOutlined, UpOutlined } from '@ant-design/icons';
+import { useBoolean, useControllableValue } from 'ahooks';
+import { Tag } from 'antd';
+import classNames from 'classnames';
+import { FC, useEffect } from 'react';
+import React from 'react';
+import styles from './index.less';
+
+const { CheckableTag } = Tag;
+
+export interface TagSelectOptionProps {
+  value: string | number | undefined;
+  style?: React.CSSProperties;
+  checked?: boolean;
+  onChange?: (value: string | number, state: boolean) => void;
+}
+
+const TagSelectOption: React.FC<TagSelectOptionProps> & {
+  isTagSelectOption: boolean;
+} = ({ children, checked, onChange, value }) => (
+  <CheckableTag
+    checked={!!checked}
+    key={value}
+    onChange={(state) => onChange && onChange(value, state)}
+  >
+    {children}
+  </CheckableTag>
+);
+
+TagSelectOption.isTagSelectOption = true;
+
+type TagSelectOptionElement = React.ReactElement<TagSelectOptionProps, typeof TagSelectOption>;
+export interface TagSelectProps {
+  onChange?: (value: (string | number)[]) => void;
+  expandable?: boolean;
+  value?: (string | number)[];
+  defaultValue?: (string | number)[];
+  style?: React.CSSProperties;
+  hideCheckAll?: boolean;
+  actionsText?: {
+    expandText?: React.ReactNode;
+    collapseText?: React.ReactNode;
+    selectAllText?: React.ReactNode;
+  };
+  className?: string;
+  Option?: TagSelectOptionProps;
+  children?: TagSelectOptionElement | TagSelectOptionElement[];
+  single?: boolean;
+  disableUnCheck?: boolean;
+  empty?: boolean;
+  isSelectAll?: boolean;
+  reverseCheckAll?: boolean;
+}
+
+const TagSelect: FC<TagSelectProps> & { Option: typeof TagSelectOption } = (props) => {
+  const {
+    children,
+    hideCheckAll = false,
+    className,
+    style,
+    expandable,
+    actionsText = {},
+    single = false,
+    disableUnCheck = false,
+    empty = false,
+    isSelectAll = false,
+    reverseCheckAll = false,
+  } = props;
+
+  const [expand, { toggle }] = useBoolean();
+
+  const [value, setValue] = useControllableValue<(string | number)[] | undefined>(props);
+
+  useEffect(() => {
+    if (empty) {
+      setValue([]);
+    }
+  }, [empty]);
+
+  const isTagSelectOption = (node: TagSelectOptionElement) =>
+    node &&
+    node.type &&
+    (node.type.isTagSelectOption || node.type.displayName === 'TagSelectOption');
+
+  const getAllTags = () => {
+    const childrenArray = React.Children.toArray(children) as TagSelectOptionElement[];
+    const checkedTags = childrenArray
+      .filter((child) => isTagSelectOption(child))
+      .map((child) => child.props.value);
+    return checkedTags || [];
+  };
+
+  const onSelectAll = (checked: boolean) => {
+    let checkedTags: (string | number)[] = [];
+    if (reverseCheckAll) {
+      setValue(undefined);
+      return;
+    }
+    if (checked) {
+      checkedTags = getAllTags();
+    }
+    setValue(checkedTags);
+  };
+
+  useEffect(() => {
+    if (isSelectAll) {
+      onSelectAll(true);
+    }
+  }, []);
+
+  const handleTagChange = (tag: string | number, checked: boolean) => {
+    let checkedTags: (string | number)[] = [...(value || [])];
+    if (single && checkedTags.length > 0) {
+      checkedTags = [checkedTags.join('')];
+    }
+    const index = checkedTags.indexOf(tag);
+    if (checked && index === -1) {
+      if (single) {
+        checkedTags = [tag];
+      } else {
+        checkedTags.push(tag);
+      }
+    } else if (!checked && index > -1 && !disableUnCheck) {
+      checkedTags.splice(index, 1);
+    }
+    setValue(checkedTags.length === 0 ? undefined : checkedTags);
+  };
+
+  const checkedAll = getAllTags().length === value?.length;
+  const hasChecked = value === undefined ? false : value?.length > 0;
+
+  const {
+    expandText = '展开',
+    collapseText = '收起',
+    selectAllText = reverseCheckAll ? '不限' : '全部',
+  } = actionsText;
+
+  const cls = classNames(styles.tagSelect, className, {
+    [styles.hasExpandTag]: expandable,
+    [styles.expanded]: expand,
+  });
+
+  return (
+    <div className={cls} style={style}>
+      {hideCheckAll ? null : (
+        <CheckableTag
+          checked={reverseCheckAll ? !hasChecked : checkedAll}
+          key="tag-select-__all__"
+          onChange={onSelectAll}
+        >
+          {selectAllText}
+        </CheckableTag>
+      )}
+      {children &&
+        React.Children.map(children, (child: TagSelectOptionElement) => {
+          if (isTagSelectOption(child)) {
+            return React.cloneElement(child, {
+              key: `tag-select-${child.props.value}`,
+              value: child.props.value,
+              checked: value && value.indexOf(child.props.value) > -1,
+              onChange: handleTagChange,
+            });
+          }
+          return child;
+        })}
+      {expandable && (
+        <a
+          className={styles.trigger}
+          onClick={() => {
+            toggle();
+          }}
+        >
+          {expand ? (
+            <>
+              {collapseText} <UpOutlined />
+            </>
+          ) : (
+            <>
+              {expandText}
+              <DownOutlined />
+            </>
+          )}
+        </a>
+      )}
+    </div>
+  );
+};
+
+TagSelect.Option = TagSelectOption;
+
+export default TagSelect;
diff --git a/webapp/packages/supersonic-fe/src/pages/SemanticModel/ChatSetting.tsx b/webapp/packages/supersonic-fe/src/pages/SemanticModel/ChatSetting.tsx
index c1b84e90d..66386f7d7 100644
--- a/webapp/packages/supersonic-fe/src/pages/SemanticModel/ChatSetting.tsx
+++ b/webapp/packages/supersonic-fe/src/pages/SemanticModel/ChatSetting.tsx
@@ -6,6 +6,7 @@ import styles from './components/style.less';
 import type { StateType } from './model';
 import { DownOutlined } from '@ant-design/icons';
 import EntitySection from './components/Entity/EntitySection';
+import RecommendedQuestionsSection from './components/Entity/RecommendedQuestionsSection';
 import { ISemantic } from './data';
 import { getDomainList } from './service';
 import OverView from './components/OverView';
@@ -130,15 +131,20 @@ const ChatSetting: React.FC<Props> = ({ domainManger, dispatch }) => {
 
   const isModelItem = [
     {
-      label: '指标场景',
+      label: '指标模式',
       key: 'metric',
       children: <EntitySection chatConfigType={ChatConfigType.AGG} />,
     },
     {
-      label: '明细场景',
+      label: '实体模式',
       key: 'dimenstion',
       children: <EntitySection chatConfigType={ChatConfigType.DETAIL} />,
     },
+    {
+      label: '推荐问题',
+      key: 'recommendedQuestions',
+      children: <RecommendedQuestionsSection />,
+    },
   ];
 
   return (
diff --git a/webapp/packages/supersonic-fe/src/pages/SemanticModel/Metric/components/MetricFilter.tsx b/webapp/packages/supersonic-fe/src/pages/SemanticModel/Metric/components/MetricFilter.tsx
new file mode 100644
index 000000000..02328c9d3
--- /dev/null
+++ b/webapp/packages/supersonic-fe/src/pages/SemanticModel/Metric/components/MetricFilter.tsx
@@ -0,0 +1,109 @@
+import { Form, Select, Input } from 'antd';
+import StandardFormRow from '@/components/StandardFormRow';
+import TagSelect from '@/components/TagSelect';
+import React, { useEffect } from 'react';
+import { SENSITIVE_LEVEL_OPTIONS } from '../../constant';
+
+const FormItem = Form.Item;
+const { Option } = Select;
+
+type Props = {
+  filterValues?: any;
+  onFiltersChange: (_: any, values: any) => void;
+};
+
+const MetricFilter: React.FC<Props> = ({ filterValues = {}, onFiltersChange }) => {
+  const [form] = Form.useForm();
+
+  useEffect(() => {
+    form.setFieldsValue({
+      ...filterValues,
+    });
+  }, [form, filterValues]);
+
+  const handleValuesChange = (value: any, values: any) => {
+    onFiltersChange(value, values);
+  };
+
+  const onSearch = (value) => {
+    if (!value) {
+      return;
+    }
+    onFiltersChange(value, form.getFieldsValue());
+  };
+
+  const filterList = [
+    {
+      title: '指标类型',
+      key: 'type',
+      options: [
+        {
+          value: 'ATOMIC',
+          label: '原子指标',
+        },
+        { value: 'DERIVED', label: '衍生指标' },
+      ],
+    },
+    {
+      title: '敏感度',
+      key: 'sensitiveLevel',
+      options: SENSITIVE_LEVEL_OPTIONS,
+    },
+  ];
+
+  return (
+    <Form
+      layout="inline"
+      form={form}
+      colon={false}
+      onValuesChange={(value, values) => {
+        if (value.keywords || value.keywordsType) {
+          return;
+        }
+        handleValuesChange(value, values);
+      }}
+      initialValues={{
+        keywordsType: 'name',
+      }}
+    >
+      <StandardFormRow key="search" block>
+        <Input.Group compact>
+          <FormItem name={'keywordsType'} noStyle>
+            <Select>
+              <Option value="name">中文名</Option>
+              <Option value="bizName">英文名</Option>
+              <Option value="id">ID</Option>
+            </Select>
+          </FormItem>
+          <FormItem name={'keywords'} noStyle>
+            <Input.Search
+              placeholder="请输入需要查询的指标信息"
+              allowClear
+              onSearch={onSearch}
+              style={{ width: 300 }}
+              enterButton
+            />
+          </FormItem>
+        </Input.Group>
+      </StandardFormRow>
+      {filterList.map((item) => {
+        const { title, key, options } = item;
+        return (
+          <StandardFormRow key={key} title={title} block>
+            <FormItem name={key}>
+              <TagSelect reverseCheckAll single>
+                {options.map((item: any) => (
+                  <TagSelect.Option key={item.value} value={item.value}>
+                    {item.label}
+                  </TagSelect.Option>
+                ))}
+              </TagSelect>
+            </FormItem>
+          </StandardFormRow>
+        );
+      })}
+    </Form>
+  );
+};
+
+export default MetricFilter;
diff --git a/webapp/packages/supersonic-fe/src/pages/SemanticModel/Metric/index.tsx b/webapp/packages/supersonic-fe/src/pages/SemanticModel/Metric/index.tsx
new file mode 100644
index 000000000..a04839196
--- /dev/null
+++ b/webapp/packages/supersonic-fe/src/pages/SemanticModel/Metric/index.tsx
@@ -0,0 +1,196 @@
+import type { ActionType, ProColumns } from '@ant-design/pro-table';
+import ProTable from '@ant-design/pro-table';
+import { message, Space } from 'antd';
+import React, { useRef, useState, useEffect } from 'react';
+import type { Dispatch } from 'umi';
+import { connect } from 'umi';
+import type { StateType } from '../model';
+import { SENSITIVE_LEVEL_ENUM } from '../constant';
+import { queryMetric } from '../service';
+import MetricFilter from './components/MetricFilter';
+
+import moment from 'moment';
+import styles from './style.less';
+
+type Props = {
+  dispatch: Dispatch;
+  domainManger: StateType;
+};
+
+type QueryMetricListParams = {
+  id?: string;
+  name?: string;
+  bizName?: string;
+  sensitiveLevel?: string;
+  type?: string;
+};
+
+const ClassMetricTable: React.FC<Props> = () => {
+  const [pagination, setPagination] = useState({
+    current: 1,
+    pageSize: 20,
+    total: 0,
+  });
+
+  const [dataSource, setDataSource] = useState<any[]>([]);
+  const actionRef = useRef<ActionType>();
+
+  useEffect(() => {
+    queryMetricList();
+  }, []);
+
+  const queryMetricList = async (params: QueryMetricListParams = {}) => {
+    const { code, data, msg } = await queryMetric({
+      ...params,
+      ...pagination,
+    });
+    const { list, pageSize, current, total } = data;
+    let resData: any = {};
+    if (code === 200) {
+      setPagination({
+        pageSize: Math.min(pageSize, 100),
+        current,
+        total,
+      });
+      setDataSource(list);
+      resData = {
+        data: list || [],
+        success: true,
+      };
+    } else {
+      message.error(msg);
+      setDataSource([]);
+      resData = {
+        data: [],
+        total: 0,
+        success: false,
+      };
+    }
+    return resData;
+  };
+
+  const columns: ProColumns[] = [
+    {
+      dataIndex: 'id',
+      title: 'ID',
+    },
+    {
+      dataIndex: 'name',
+      title: '指标名称',
+    },
+    {
+      dataIndex: 'alias',
+      title: '别名',
+      search: false,
+    },
+    {
+      dataIndex: 'bizName',
+      title: '字段名称',
+    },
+    {
+      dataIndex: 'sensitiveLevel',
+      title: '敏感度',
+      valueEnum: SENSITIVE_LEVEL_ENUM,
+    },
+    {
+      dataIndex: 'createdBy',
+      title: '创建人',
+      search: false,
+    },
+    {
+      dataIndex: 'description',
+      title: '描述',
+      search: false,
+    },
+    {
+      dataIndex: 'type',
+      title: '指标类型',
+      // search: false,
+      valueEnum: {
+        ATOMIC: '原子指标',
+        DERIVED: '衍生指标',
+      },
+    },
+
+    {
+      dataIndex: 'updatedAt',
+      title: '更新时间',
+      search: false,
+      render: (value: any) => {
+        return value && value !== '-' ? moment(value).format('YYYY-MM-DD HH:mm:ss') : '-';
+      },
+    },
+  ];
+
+  const handleFilterChange = async (filterParams: {
+    keywordsType: string;
+    keywords: string;
+    sensitiveLevel: string;
+    type: string;
+  }) => {
+    const params: QueryMetricListParams = {};
+    const { keywordsType, keywords, sensitiveLevel, type } = filterParams;
+    if (keywordsType && keywords) {
+      params[keywordsType] = keywords;
+    }
+    const sensitiveLevelValue = sensitiveLevel?.[0];
+    const typeValue = type?.[0];
+    if (sensitiveLevelValue) {
+      params.sensitiveLevel = sensitiveLevelValue;
+    }
+    if (type) {
+      params.type = typeValue;
+    }
+
+    await queryMetricList(params);
+  };
+
+  return (
+    <>
+      <div className={styles.metricFilterWrapper}>
+        <MetricFilter
+          onFiltersChange={(_, values) => {
+            handleFilterChange(values);
+          }}
+        />
+      </div>
+      <ProTable
+        className={`${styles.metricTable}`}
+        actionRef={actionRef}
+        // headerTitle="指标列表"
+        rowKey="id"
+        search={false}
+        dataSource={dataSource}
+        columns={columns}
+        pagination={pagination}
+        tableAlertRender={() => {
+          return false;
+        }}
+        onChange={(data: any) => {
+          const { current, pageSize, total } = data;
+          setPagination({
+            current,
+            pageSize,
+            total,
+          });
+        }}
+        size="small"
+        options={{ reload: false, density: false, fullScreen: false }}
+        // toolBarRender={() => [
+        //   <Button
+        //     key="create"
+        //     type="primary"
+        //     onClick={() => {
+        //       setMetricItem(undefined);
+        //     }}
+        //   >
+        //     创建指标
+        //   </Button>,
+        // ]}
+      />
+    </>
+  );
+};
+export default connect(({ domainManger }: { domainManger: StateType }) => ({
+  domainManger,
+}))(ClassMetricTable);
diff --git a/webapp/packages/supersonic-fe/src/pages/SemanticModel/ProjectManager.tsx b/webapp/packages/supersonic-fe/src/pages/SemanticModel/ProjectManager.tsx
index 7b7541382..69bb7a12a 100644
--- a/webapp/packages/supersonic-fe/src/pages/SemanticModel/ProjectManager.tsx
+++ b/webapp/packages/supersonic-fe/src/pages/SemanticModel/ProjectManager.tsx
@@ -7,6 +7,7 @@ import ClassDimensionTable from './components/ClassDimensionTable';
 import ClassMetricTable from './components/ClassMetricTable';
 import PermissionSection from './components/Permission/PermissionSection';
 import DatabaseSection from './components/Database/DatabaseSection';
+import EntitySettingSection from './components/Entity/EntitySettingSection';
 import OverView from './components/OverView';
 import styles from './components/style.less';
 import type { StateType } from './model';
@@ -149,11 +150,10 @@ const DomainManger: React.FC<Props> = ({ domainManger, dispatch }) => {
 
   const isModelItem = [
     {
-      label: '可视化建模',
+      label: '画布',
       key: 'xflow',
       children: (
-        <div style={{ width: '100%', height: 'calc(100vh - 200px)' }}>
-          {/* <SemanticFlow /> */}
+        <div style={{ width: '100%', marginTop: -20 }}>
           <SemanticGraphCanvas />
         </div>
       ),
@@ -178,6 +178,12 @@ const DomainManger: React.FC<Props> = ({ domainManger, dispatch }) => {
       key: 'metric',
       children: <ClassMetricTable />,
     },
+    {
+      label: '实体',
+      key: 'entity',
+      children: <EntitySettingSection />,
+    },
+
     {
       label: '权限管理',
       key: 'permissonSetting',
diff --git a/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticFlows/components/XflowJsonSchemaFormDrawerForm.tsx b/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticFlows/components/XflowJsonSchemaFormDrawerForm.tsx
index 0ba3965ff..7ac421e2e 100644
--- a/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticFlows/components/XflowJsonSchemaFormDrawerForm.tsx
+++ b/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticFlows/components/XflowJsonSchemaFormDrawerForm.tsx
@@ -7,7 +7,7 @@ import { connect } from 'umi';
 import { DATASOURCE_NODE_RENDER_ID } from '../constant';
 import DataSourceRelationFormDrawer from './DataSourceRelationFormDrawer';
 import DataSourceCreateForm from '../../Datasource/components/DataSourceCreateForm';
-import ClassDataSourceTypeModal from '../../components/ClassDataSourceTypeModal';
+import ClassDataSourceTypeModal from '../../components/ClassDataSourceTypeModal1';
 import { GraphApi } from '../service';
 import { SemanticNodeType } from '../../enum';
 import type { StateType } from '../../model';
diff --git a/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticGraph/components/ContextMenu.tsx b/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticGraph/components/ContextMenu.tsx
index 23ca7d24a..3619f129d 100644
--- a/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticGraph/components/ContextMenu.tsx
+++ b/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticGraph/components/ContextMenu.tsx
@@ -6,34 +6,36 @@ import { SemanticNodeType } from '../../enum';
 import { SEMANTIC_NODE_TYPE_CONFIG } from '../../constant';
 
 type InitContextMenuProps = {
-  graphShowType: string;
+  graphShowType?: string;
   onMenuClick?: (key: string, item: Item) => void;
 };
 
 export const getMenuConfig = (props?: InitContextMenuProps) => {
-  const { graphShowType, onMenuClick } = props || {};
+  const { onMenuClick } = props || {};
   return {
     getContent(evt) {
       const nodeData = evt?.item?._cfg?.model;
       const { name, nodeType } = nodeData as any;
       if (nodeData) {
         const nodeTypeConfig = SEMANTIC_NODE_TYPE_CONFIG[nodeType] || {};
-        let ulNode = `<ul>
+        let ulNode = `
         <li title='编辑' key='edit' >编辑</li>
         <li title='删除' key='delete' >删除</li>
-      </ul>`;
+     `;
         if (nodeType === SemanticNodeType.DATASOURCE) {
-          if (graphShowType) {
-            const typeString = graphShowType === SemanticNodeType.DIMENSION ? '维度' : '指标';
-            ulNode = `<ul>
-              <li title='新增${typeString}' key='create' >新增${typeString}</li>
-            </ul>`;
-          }
+          ulNode = `
+              <li title='新增维度' key='createDimension' >新增维度</li>
+              <li title='新增指标' key='createMetric' >新增指标</li>
+              <li title='编辑' key='editDatasource' >编辑</li>
+              <li title='删除' key='deleteDatasource' >删除</li>
+            `;
         }
         const header = `${name}`;
         return `<div class="g6ContextMenuContainer">
           <h3>${presetsTagDomString(nodeTypeConfig.label, nodeTypeConfig.color)}${header}</h3>
+          <ul>
         ${ulNode}
+        </ul>
         </div>`;
       }
       return `<div>当前节点信息获取失败</div>`;
diff --git a/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticGraph/components/DeleteConfirmModal.tsx b/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticGraph/components/DeleteConfirmModal.tsx
index 131132876..02628b306 100644
--- a/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticGraph/components/DeleteConfirmModal.tsx
+++ b/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticGraph/components/DeleteConfirmModal.tsx
@@ -1,11 +1,10 @@
-import { Button, Modal, message } from 'antd';
+import { Modal, message } from 'antd';
 import React, { useState } from 'react';
 import { SemanticNodeType } from '../../enum';
-import { deleteDimension, deleteMetric } from '../../service';
+import { deleteDimension, deleteMetric, deleteDatasource } from '../../service';
 
 type Props = {
   nodeData: any;
-  nodeType: SemanticNodeType;
   onOkClick: () => void;
   onCancelClick: () => void;
   open: boolean;
@@ -13,7 +12,6 @@ type Props = {
 
 const DeleteConfirmModal: React.FC<Props> = ({
   nodeData,
-  nodeType,
   onOkClick,
   onCancelClick,
   open = false,
@@ -21,11 +19,21 @@ const DeleteConfirmModal: React.FC<Props> = ({
   const [confirmLoading, setConfirmLoading] = useState(false);
   const deleteNode = async () => {
     setConfirmLoading(true);
-    const { id } = nodeData;
-    let deleteQuery = deleteDimension;
+    const { id, nodeType } = nodeData;
+    let deleteQuery;
+    if (nodeType === SemanticNodeType.DIMENSION) {
+      deleteQuery = deleteDimension;
+    }
     if (nodeType === SemanticNodeType.METRIC) {
       deleteQuery = deleteMetric;
     }
+    if (nodeType === SemanticNodeType.DATASOURCE) {
+      deleteQuery = deleteDatasource;
+    }
+    if (!deleteQuery) {
+      message.error('当前节点类型不是维度，指标，数据源中的一种，请确认节点数据');
+      return;
+    }
     const { code, msg } = await deleteQuery(id);
     setConfirmLoading(false);
     if (code === 200) {
diff --git a/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticGraph/components/GraphToolBar.tsx b/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticGraph/components/GraphToolBar.tsx
new file mode 100644
index 000000000..64601960e
--- /dev/null
+++ b/webapp/packages/supersonic-fe/src/pages/SemanticModel/SemanticGraph/components/GraphToolBar.tsx
@@ -0,0 +1,66 @@
+import { Button, Space } from 'antd';
+import { PlusOutlined } from '@ant-design/icons';
+import React from 'react';
+
+import { connect } from 'umi';
+import type { StateType } from '../../model';
+
+type Props = {
+  domainManger: StateType;
+  onClick: (params?: { eventName?: string }) => void;
+  [key: string]: any;
+};
+
+const GraphToolBar: React.FC<Props> = ({ onClick }) => {
+  return (
+    <div
+      style={{
+        padding: 0,
+        backgroundColor: '#fff',
+        display: 'flex',
+        justifyContent: 'end',
+        position: 'absolute',
+        top: 20,
+        right: 20,
+        zIndex: 1,
+      }}
+    >
+      <Space>
+        <Button
+          key="createDatabaseBtn"
+          icon={<PlusOutlined />}
+          size="small"
+          onClick={() => {
+            onClick?.({ eventName: 'createDatabase' });
+          }}
+        >
+          新建数据源
+        </Button>
+        <Button
+          key="createDimensionBtn"
+          icon={<PlusOutlined />}
+          size="small"
+          onClick={() => {
+            onClick?.({ eventName: 'createDimension' });
+          }}
+        >
+          新建维度
+        </Button>
+        <Button
+          key="createMetricBtn"
+          icon={<PlusOutlined />}
+          size="small"
+          onClick={() => {
+            onClick?.({ eventName: 'createMetric' });
+          }}
+        >
+          新建指标
+        </Button>
+      </Space>
+    </div>
+  );
+};
+
+export default connect(({ domainManger }: { domainManger: StateType }) => ({
+  domainManger,
+}))(GraphToolBar);
